<%@ Language=VBScript %>
<html>
	<head>
		<title>Add Patient</title>
		<meta name="GENERATOR" content="Microsoft Visual Studio .NET 7.1">
		<meta name="vs_targetSchema" content="http://schemas.microsoft.com/intellisense/ie5">
	</head>
	<body>
		<center><h1>Add Patient</h1>

<!-- #include file = "Password.inc" -->

<% 
	' Copy the form data to local variables
	Address = Server.HTMLEncode(Request.Form("Address"))
	CCN     = Server.HTMLEncode(Request.Form("CCN"))
	City    = Server.HTMLEncode(Request.Form("City"))
	Name    = Server.HTMLEncode(Request.Form("Name"))
	SSN     = Server.HTMLEncode(Request.Form("SSN"))

	' Build the blood type and expiration date strings
	BloodType = Server.HTMLEncode(Request.Form("BType")) & Server.HTMLEncode(Request.Form("Level"))
	ExpDate   = Server.HTMLEncode(Request.Form("ExpMonth")) & Server.HTMLEncode(Request.Form("ExpYear"))
	
	' Connect to the DrOffice database
	Set oConn = CreateObject("adodb.connection")
	oConn.Open "DROfficeDB", "DBTest", Password

	' Get the value for the 'sensitive' data category	
	Set oRS = oConn.Execute("SELECT DataCategory FROM DataCategory WHERE Name = 'Sensitive'")
	nSensitive = oRS("DataCategory")

	' Get the column name for each column	
	Set oRS = oConn.Execute("SELECT Top 0 * FROM Patients")
	Set Flds = oRS.Fields

	' Copy the data from the entry form into local variables. Encrypt the data where
	' appropriate.
	For Each Fld In Flds
		' Get the data category for each table column.
		strSQL = "SELECT CAST([value] AS varchar) AS [Value] FROM " &_
						"::FN_LISTEXTENDEDPROPERTY('DataCategory', 'User', " &_
						"'dbo','table', 'patients', 'column', '" & Fld.name & "')"
								
		Set oRS = oConn.Execute(strSQL)
		
		If CInt(oRS("Value")) = nSensitive Then
			Sensitive = true
		Else
			Sensitive = false
		End if
		
		' Check each column to see if its data category is set to sensitive. If so
		' Then encrypt the column value.
		If Fld.Name = "Name" And Sensitive Then
				Name = EncryptString(Name)
		Elseif Fld.Name = "Address" And Sensitive Then
				Address = EncryptString(Address)
		Elseif Fld.Name = "City" And Sensitive Then
				City = EncryptString(City)
		Elseif Fld.Name = "CC#" And Sensitive Then
				CCN = EncryptString(CCN)
		Elseif Fld.Name = "ExpDate" And Sensitive Then
				ExpDate = EncryptString(ExpDate)
		Elseif Fld.Name = "SSN" And Sensitive Then
				SSN = EncryptString(SSN)
		Elseif Fld.Name = "BloodType" And Sensitive Then
				BloodType = EncryptString(BloodType)
		End if
	Next

	' Setup the command object
	Set oCmd = CreateObject("adodb.command")
	oCmd.ActiveConnection = oConn
	oCmd.CommandType = 1
	oCmd.Prepared = true

	' Insert the form data into the table
	oCmd.CommandText = "INSERT INTO Patients (Name, Address, City, ExpDate, CC#, SSN, BloodType) " &_
					   "VALUES(?, ?, ?, ?, ?, ?, ?)"
	
	' Load the patient values into parameters
	Set Parm1 = oCmd.CreateParameter("Name", 200, 1, 200, Name)
	oCmd.Parameters.Append parm1
	Set Parm2 = oCmd.CreateParameter("Address", 200, 1, 200, Address)
	oCmd.Parameters.Append Parm2
	Set Parm3 = oCmd.CreateParameter("City", 200, 1, 200, City)
	oCmd.Parameters.Append Parm3
	Set Parm4 = oCmd.CreateParameter("ExpDate", 200, 1, 200, ExpDate)
	oCmd.Parameters.Append Parm4
	Set Parm5 = oCmd.CreateParameter("CC#", 200, 1, 200, CCN)
	oCmd.Parameters.Append Parm5
	Set Parm6 = oCmd.CreateParameter("SSN", 200, 1, 200, SSN)
	oCmd.Parameters.Append Parm6
	Set Parm7 = oCmd.CreateParameter("BloodType", 200, 1, 200, BloodType)
	oCmd.Parameters.Append Parm7

	' Send the select statement to the database
	oCmd.Execute

	Set Flds = Nothing
	Set oRS = Nothing
	Set oCmd = Nothing
	Set oConn = Nothing
	
	Response.Write "<P><h2>Record Created"

' This function (simulates) the encryption of a string. This function should
' not be used as a true encryption routine.
Function EncryptString(Value)
	Const CAPICOM_ENCRYPTION_ALGORITHM_3DES      = 3
	Const CAPICOM_ENCRYPTION_KEY_LENGTH_MAXIMUM  = 0

	' Create the EncryptedData object.
	Set EncryptedData = CreateObject("CAPICOM.EncryptedData")
  
	' Set algorithm, key size, and encryption secret.
	EncryptedData.SetSecret Secret
	EncryptedData.Content = Value
	EncryptString = EncryptedData.Encrypt
End Function
%>
	</body>
</html>
